 #include <X11/Xlib.h>
 #include <stdio.h>
 #include <stdlib.h>
 #define LEFT_BORDER 400
 #define DOWN_BORDER 300
 #define x0 200
 #define y0 100

 #define UP 111
 #define DOWN 116
 #define LEFT 113
 #define RIGHT 114



inline char selfeat (unsigned int *x, unsigned int  *y,
                      unsigned int xn, unsigned int  yn,
                      unsigned int LENGTH)
{
    unsigned int count=1;
    while (count != LENGTH) 
    {
        if ((x[count] == xn) && (y[count] == yn)) return (0);
        count++;
    }
    return (1);
}



inline void blacktohead (Display *d, Window w, unsigned int s,
         unsigned int *x, unsigned int *y)
{
    XSetForeground(d, DefaultGC(d, s), 0x000000);
    XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]); //закрашиваем черным то место, где была голова
}



inline void whitetoass (Display *d, Window w, unsigned int s,
         unsigned int *x, unsigned int *y, unsigned int mv)
{
    XSetForeground(d, DefaultGC(d, s), 0xFFFFFF);
    XDrawPoint(d, w, DefaultGC(d, s), x[mv], y[mv]); //закрашиваем белым то место, где был зад
}



inline void step (unsigned int *x, unsigned int *y, unsigned int mv)
{
    y[mv]=*y;
    x[mv]=*x;
}



inline void redhead (Display *d, Window w, unsigned int s,
         unsigned int *x, unsigned int *y)
{
    XSetForeground(d, DefaultGC(d, s), 0xFF0000);
    XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]); //рисуем красную головку
}

inline void draweatpoint (Display *d, Window w, unsigned int s,
         unsigned int *xrand, unsigned int *yrand)
{
    XSetForeground(d, DefaultGC(d, s), 0x00FF00);
    XDrawPoint(d, w, DefaultGC(d, s), *xrand, *yrand); //рисуем точку для пожирания
}

inline void read_KeyPress (XEvent *eventp, unsigned int *x,
                   unsigned int  *y, unsigned int *mv,
                   char *plusminus, Display *d, Window w,
                   unsigned int s, unsigned int *LENGTH,
                   unsigned int *xrand, unsigned int *yrand)
{
    unsigned int Xnw=0, Ynw=0;
    XKeyEvent *e = (XKeyEvent *) eventp;
    switch (e->keycode)
    {
        case UP:
            Ynw = y[0]-1;
            Xnw = x[0];
            break;
        case DOWN:
            Ynw = (y[0]+1);
            Xnw = x[0];
            break;
        case LEFT:
            Ynw = y[0];
            Xnw = x[0]-1;
            break;
        case RIGHT:
            Ynw = y[0];
            Xnw = x[0]+1;
    }
    if (((Xnw!=x[0]) ^ (Ynw!=y[0])) && ((Xnw) != (LEFT_BORDER-1)) \
        && ((Ynw) != (DOWN_BORDER-1)) && (selfeat (x, y, Xnw, Ynw, *LENGTH)) \
        && ((Xnw) != 0) && ((Ynw) != 0) )
    {
        blacktohead (d, w, s, x, y);
        whitetoass (d, w, s, x, y, *mv);
        step (x, y, *mv);
        x[0]=Xnw;
        y[0]=Ynw;
        redhead (d, w, s, x, y);
/*        switch (*mv)  //Почему это не работает
//Пишет error: case label does not reduce to an integer constant
        {
            case (*LENGTH): {*mv=1; *plusminus=1; break;}
            case 1: {*mv=*LENGTH; *plusminus=-1;}
        }*/
        if ((*mv) == (*LENGTH)) {*mv=1; *plusminus=1;}//заменил его этим
        else if ((*mv) == 1) {*mv=*LENGTH; *plusminus=-1;}
        *mv = *mv+*plusminus;
        if ((*x == *xrand) && (*y == *xrand))
            {
            *LENGTH = *LENGTH+20;
            *mv=1;
            }
        draweatpoint (d, w, s, xrand, yrand);
    }
}


 
int main(void) 
{
    unsigned int xrand=5;
    unsigned int yrand=5;
    unsigned int LENGTH = 10;
    unsigned int x[500], y[500];
    Display *d;
    Window w;
    unsigned int s;
    unsigned int mv; //переброс пикселей из зада вперед
    unsigned int count;
    char plusminus=0;
    XEvent e;
    
                        /* open connection with the server */
    d = XOpenDisplay(NULL);
    if (d == NULL)
    {
        fprintf(stderr, "Cannot open display\n");
        exit(1);
    }
 
    s = DefaultScreen(d);
                        /* create window */
    w = XCreateSimpleWindow(d, RootWindow(d, s), 10, 10, LEFT_BORDER,
                           DOWN_BORDER, 1, BlackPixel(d, s),
                           WhitePixel(d, s));
                        /* select kind of events we are interested in */
    XSelectInput(d, w, ExposureMask | KeyPressMask);
                        /* map (show) the window */
    XMapWindow(d, w);
    count = 2;
    do
    {
        x[count]=1+x0-count;
        y[count]=y0;
        count++;
    }
    while (count != (LENGTH));
    do
    {
        x[count]=LEFT_BORDER;
        y[count]=DOWN_BORDER;
        count++;
    }
    while (count != 500);
    mv=1;
    x[0]=x0;
    y[0]=y0;
    x[1]=x0-LENGTH+1;
    y[1]=y0;
    
                           /* event loop */
    draweatpoint (d, w, s, &xrand, &yrand); 
    while (1)
    {
        XNextEvent(d, &e);
        if (e.type == Expose)
        {
            XSetForeground(d, DefaultGC(d, s), 0xFF0000);
            XDrawPoint(d, w, DefaultGC(d, s), x[0], y[0]);
            count=1;
            XSetForeground(d, DefaultGC(d, s), 0x000000);
            //рисуем змею
            do
            {
                XDrawPoint(d, w, DefaultGC(d, s), x[count], y[count]);
                count++;
            }
            while (count != (LENGTH));
            draweatpoint (d, w, s, &xrand, &yrand);
        }    
        if (e.type == KeyPress)
        {
            read_KeyPress (&e, x, y, &mv, &plusminus, d, w, s, &LENGTH,\
            &xrand, &yrand );
        }
    }
}